
;   /*\
;---|*|---====< MS-DOS Device Driver Structures >====----
;---|*|
;---|*| Copyright (c) 1991, Media Vision, Inc.	All Rights Reserved.
;---|*|
;   \*/

;
; generic request header
;
rh		struc
  rh_len	db	?		; len of packet
  rh_unit	db	?		; unit code (block devices only)
  rh_cmd	db	?		; device driver command
  rh_status	dw	?		; returned by device driver
  rh_res1	dd	?		; reserved
  rh_res2	dd	?		; reserved
rh		ends

;
; Initialization (command 0)
;
rh0             struc
  rh0_rh	db	size rh dup (?) ; fixed portion
  rh0_nunits	db	?		; number of units (block devices only)
  rh0_brk_ofs	dw	?		; offset for break
  rh0_brk_seg	dw	?		; segment for break
  rh0_bpb_tbo	dw	?		; offset of pointer to BPB array
  rh0_bpb_tbs	dw	?		; segment of pointer to BPB array
  rh0_drv_ltr	db	?		; first available drive (DOS 3+) (block only)
rh0		ends

;
; Media_Check (command 1)
;
rh1             struc
  rh1_rh	db	size rh dup (?) ; fixed portion
  rh1_media	db	?		; media descriptor from DPB
  rh1_md_stat	db	?		; media status returned by device driver
  rh1_volid_ofs dw	?		; offset of volume ID DOS 3+ only
  rh1_volid_seg dw	?		; segment of volume ID DOS 3+ only
rh1		ends

;
; Get_BPB (command 2)
;
rh2             struc
  rh2_rh	db	size rh dup(?)	; fixed portion
  rh2_media	db	?		; media descriptor from DPB
  rh2_buf_ofs	dw	?		; offset of data transfer area
  rh2_buf_seg	dw	?		; segment of data transfer area
  rh2_pbpbo	dw	?		; offset of pointer to BPB
  rh2_pbpbs	dw	?		; segment of pointer to BPB
rh2		ends

;
; IOCTL_INPUT (command 3)
;
rh3             struc
  rh3_rh	db	size rh dup(?)	; fixed portion
  rh3_media	db	?		; media descriptor from DPB
  rh3_buf_ofs	dw	?		; offset of data transfer area
  rh3_buf_seg	dw	?		; segment of data transfer area
  rh3_count	dw	?		; transfer count (sectors for block, bytes for character)
  rh3_start	dw	?		; start sector number (block devices only)
rh3		ends

;
; INPUT (command 4)
;
rh4             struc
  rh4_rh	db	size rh dup(?)	; fixed portion
  rh4_media	db	?		; media descriptor from DPB
  rh4_buf_ofs	dw	?		; offset of data transfer area
  rh4_buf_seg	dw	?		; segment of data transfer area
  rh4_count	dw	?		; transfer count (sectors for block,bytes for character)
  rh4_start	dw	?		; start sector number (block devices only)
  rh4_volid_ofs dw	?		; offset of volume ID DOS 3+ only
  rh4_volid_seg dw	?		; segment of volume ID DOS 3+ only
rh4		ends

;
; ND_INPUT (command 5)
;
rh5             struc
  rh5_rh	db	size rh dup (?) ; fixed portion
  rh5_return	db	?		; character returned
rh5		ends

;
; Input_Status (command 6)
;
rh6             struc
  rh6_len	db	?		; len of packet
  rh6_unit	db	?		; unit code (block devices only)
  rh6_cmd	db	?		; device driver command
  rh6_status	dw	?		; returned by device driver
  rh6_res1	dd	?		; reserved
  rh6_res2	dd	?		; reserved
rh6		ends

;
; Input_Flush (command 7)
;
rh7             struc
  rh7_len	db	?		; len of packet
  rh7_unit	db	?		; unit code (block devices only)
  rh7_cmd	db	?		; device driver command
  rh7_status	dw	?		; returned by device driver
  rh7_res1	dd	?		; reserved
  rh7_res2	dd	?		; reserved
rh7		ends

;
; OUTPUT (command 8)
;
rh8             struc
  rh8_rh	db	size rh dup(?)	; fixed portion
  rh8_media	db	?		; media descriptor from DPB
  rh8_buf_ofs	dw	?		; offset of data transfer area
  rh8_buf_seg	dw	?		; segment of data transfer area
  rh8_count	dw	?		; transfer count (sectors for block,bytes for character)
  rh8_start	dw	?		; start sector number (block devices only)
  rh8_volid_ofs dw	?		; offset of volume ID DOS 3+ only
  rh8_volid_seg dw	?		; segment of volume ID DOS 3+ only
rh8		ends

;
; OUTPUT_VERIFY (command 9)
;
rh9             struc
  rh9_rh	db	size rh dup(?)	; fixed portion
  rh9_media	db	?		; media descriptor from DPB
  rh9_buf_ofs	dw	?		; offset of data transfer area
  rh9_buf_seg	dw	?		; segment of data transfer area
  rh9_count	dw	?		; transfer count (sectors for block,bytes for character)
  rh9_start	dw	?		; start sector number (block devices only)
  rh9_volid_ofs dw	?		; offset of volume ID DOS 3+ only
  rh9_volid_seg dw	?		; segment of volume ID DOS 3+ only
rh9		ends

;
; Output_Status (command 10)
;
rh10            struc
  rh10_len	db	?		; len of packet
  rh10_unit	db	?		; unit code (block devices only)
  rh10_cmd	db	?		; device driver command
  rh10_status	dw	?		; returned by device driver
  rh10_res1	dd	?		; reserved
  rh10_res2	dd	?		; reserved
rh10		ends

;
; Output_Flush (command 11)
;
rh11            struc
  rh11_len	db	?		; len of packet
  rh11_unit	db	?		; unit code (block devices only)
  rh11_cmd	db	?		; device driver command
  rh11_status	dw	?		; returned by device driver
  rh11_res1	dd	?		; reserved
  rh11_res2	dd	?		; reserved
rh11		ends

;
; IOCTL_OUTPUT (command 12)
;
rh12            struc
  rh12_rh	db	size rh dup(?)	; fixed portion
  rh12_media	db	?		; media descriptor from DPB
  rh12_buf_ofs	dw	?		; offset of data transfer area
  rh12_buf_seg	dw	?		; segment of data transfer area
  rh12_count	dw	?		; transfer count (sectors for block,bytes for character)
  rh12_start	dw	?		; start sector number (block devices only)
rh12		ends

;
; Open (command 13)
;
rh13            struc
  rh13_len	db	?		; len of packet
  rh13_unit	db	?		; unit code (block devices only)
  rh13_cmd	db	?		; device driver command
  rh13_status	dw	?		; returned by device driver
  rh13_res1	dd	?		; reserved
  rh13_res2	dd	?		; reserved
rh13		ends

;
; Close command 14)
;
rh14            struc
  rh14_len	db	?		; len of packet
  rh14_unit	db	?		; unit code (block devices only)
  rh14_cmd	db	?		; device driver command
  rh14_status	dw	?		; returned by device driver
  rh14_res1	dd	?		; reserved
  rh14_res2	dd	?		; reserved
rh14		ends

;
; Removable (command 15)
;
rh15            struc
  rh15_len	db	?		; len of packet
  rh15_unit	db	?		; unit code (block devices only)
  rh15_cmd	db	?		; device driver command
  rh15_status	dw	?		; returned by device driver
  rh15_res1	dd	?		; reserved
  rh15_res2	dd	?		; reserved
rh15		ends

;
; OUTPUT_BUSY (command 16)
;
rh16            struc
  rh16_rh	db	size rh dup (?) ; fixed portion
  rh16_media	db	?		; media descriptor
  rh16_buf_ofs	dw	?		; offset of data transfer area
  rh16_buf_seg	dw	?		; segment of data transfer area
  rh16_count	dw	?		; byte count returned from device driver
rh16		ends

;
; (command 17)
;
rh17            struc
  rh17_len	db	?		; len of packet
  rh17_unit	db	?		; unit code (block devices only)
  rh17_cmd	db	?		; device driver command
  rh17_status	dw	?		; returned by device driver
  rh17_res1	dd	?		; reserved
  rh17_res2	dd	?		; reserved
rh17		ends

;
; (command 18)
;
rh18            struc
  rh18_len	db	?		; len of packet
  rh18_unit	db	?		; unit code (block devices only)
  rh18_cmd	db	?		; device driver command
  rh18_status	dw	?		; returned by device driver
  rh18_res1	dd	?		; reserved
  rh18_res2	dd	?		; reserved
rh18		ends

;
; Generic_IOCTL (command 19)
;
rh19            struc
  rh19_rh	db	size rh dup (?) ; fixed portion
  rh19_major	db	?		; major function
  rh19_minor	db	?		; minor function
  rh19_SI	dw	?		; contents of SI register
  rh19_DI	dw	?		; contents of DI register
  rh19_pkt_ofs	dw	?		; offset of generic IOCTL request
  rh19_pkt_seg	dw	?		; segment of generic IOCTL request
rh19		ends

;
; (command 20)
;
rh20            struc
  rh20_len	db	?		; len of packet
  rh20_unit	db	?		; unit code (block devices only)
  rh20_cmd	db	?		; device driver command
  rh20_status	dw	?		; returned by device driver
  rh20_res1	dd	?		; reserved
  rh20_res2	dd	?		; reserved
rh20		ends

;
; (command 21)
;
rh21            struc
  rh21_len	db	?		; len of packet
  rh21_unit	db	?		; unit code (block devices only)
  rh21_cmd	db	?		; device driver command
  rh21_status	dw	?		; returned by device driver
  rh21_res1	dd	?		; reserved
  rh21_res2	dd	?		; reserved
rh21		ends

;
; (command 22)
;
rh22            struc
  rh22_len	db	?		; len of packet
  rh22_unit	db	?		; unit code (block devices only)
  rh22_cmd	db	?		; device driver command
  rh22_status	dw	?		; returned by device driver
  rh22_res1	dd	?		; reserved
  rh22_res2	dd	?		; reserved
rh22		ends

;
; Get_Device (command 23)
;
rh23            struc
  rh23_rh	db	size rh dup (?) ; fixed portion
  rh23_IO	db	?		; Input (unit code) Output (last device)
  rh23_dev_cmd	db	?		; command code
  rh23_dev_stat dw	?		; status
  rh23_reserved dd	?		; reserved
rh23		ends

;
; Set_Device (command 24)
;
rh24            struc
  rh24_rh	db	size rh dup (?) ; fixed portion
  rh24_IO	db	?		; Input (unit code) Output (last device)
  rh24_dev_cmd	db	?		; command code
  rh24_dev_stat dw	?		; status
  rh24_reserved dd	?		; reserved
rh24		ends

;
; commands that do not have unique portions to the request header:
;
;       INPUT_STATUS    (command 6)
;	INPUT_FLUSH	(command 7)
;	OUTPUT_STATUS	(command 10)
;	OUTPUT_FLUSH	(command 11)
;	OPEN		(command 13)
;	CLOSE		(command 14)
;	REMOVEABLE	(command 15)
;	 

;   /*\
;---|*| end of DDRIVER.INC
;   \*/

